#!/bin/bash

if [ $# -ne 1 || $# -ne 2]; then
    echo "Usage: ./create-sources VERSION"
    exit 1
fi

VERSION=${1}


mkdir -p smack
rm -Rf smack/*
cd smack
for m in bosh \
 compression-jzlib \
 core \
 debug \
 experimental \
 extensions \
 legacy \
 resolver-dnsjava \
 resolver-javax \
 resolver-minidns \
 tcp \
 android \
 android-extensions \
 debug-slf4j \
 im \
 java7 \
 jingle-old \
 sasl-javax \
 sasl-provided; do
    mkdir -p smack-${m}
    (
      cd smack-${m}
      wget -O pom.xml http://repo1.maven.org/maven2/org/igniterealtime/smack/smack-${m}/${VERSION}/smack-${m}-${VERSION}.pom
    )
done

tar cJf ../smack-${VERSION}-poms.tar.xz *